/*
 File: link_cleanser.h
 Date and Time: Fri Jan 30 18:55:14 2015 
*/
#ifndef __link_cleanser_h__
#define __link_cleanser_h__ 1
#include "yacco2.h"
#include "yacco2_T_enumeration.h"
#include "yacco2_k_symbols.h"
#include "yacco2_err_symbols.h"
#include "yacco2_terminals.h"
#include "yacco2_characters.h"

#include "linker_id.h"
#include "ws.h"
#include "c_comments.h"
#include "c_string.h"
#include "bad_char_set.h"
#include "eol.h"
#include "int_no.h"
  
// monolithic grammar: no thread
extern yacco2::State S1_Clink_cleanser;
namespace NS_link_cleanser {
using namespace NS_yacco2_T_enum;// enumerate
using namespace yacco2;
struct fsm_rules_reuse_table_type{
 fsm_rules_reuse_table_type();
 int no_rules_entries_;
 Per_rule_s_reuse_table* per_rule_s_table_[3];
};
class Clink_cleanser: public yacco2::CAbs_fsm {
 public:
  enum rules_and_subrules{
   start_of_rule_list = NS_yacco2_T_enum::T_Enum::sum_total_T
   ,R_Rpass3_ = 569//start_of_rule_list + 0
    ,rhs1_Rpass3_ = 1
    ,rhs2_Rpass3_ = 2
   ,R_Relems_ = 570//start_of_rule_list + 2
    ,rhs1_Relems_ = 3
    ,rhs2_Relems_ = 4
   ,R_Rtoken_ = 571//start_of_rule_list + 4
    ,rhs1_Rtoken_ = 5
    ,rhs2_Rtoken_ = 6
    ,rhs3_Rtoken_ = 7
    ,rhs4_Rtoken_ = 8
    ,rhs5_Rtoken_ = 9
    ,rhs6_Rtoken_ = 10
    ,rhs7_Rtoken_ = 11
    ,rhs8_Rtoken_ = 12
    ,rhs9_Rtoken_ = 13
    ,rhs10_Rtoken_ = 14
    ,rhs11_Rtoken_ = 15
    ,rhs12_Rtoken_ = 16
    ,rhs13_Rtoken_ = 17
    ,rhs14_Rtoken_ = 18
    ,rhs15_Rtoken_ = 19
  };
  //no of la sets = 2
  //no of states = 22
  Clink_cleanser();
  ~Clink_cleanser();
  void op();
  bool failed();
  void reduce_rhs_of_rule
      (yacco2::UINT Sub_rule_no,yacco2::Rule_s_reuse_entry** Recycled_rule);
  fsm_rules_reuse_table_type fsm_rules_reuse_table;
  static int rhs_to_rules_mapping_[20];
 };
struct Rpass3;
struct Relems;
struct Rtoken;
struct Rpass3:public yacco2::CAbs_lr1_sym {
  Rpass3(yacco2::Parser* P);
  void op();
  public:
};

struct Relems:public yacco2::CAbs_lr1_sym {
  Relems(yacco2::Parser* P);
  public:
};

struct Rtoken:public yacco2::CAbs_lr1_sym {
  Rtoken(yacco2::Parser* P);
  public:
  void sr2();
  void sr3();
  void sr4();
  void sr5();
  void sr6();
  void sr7();
  void sr8();
  void sr9();
  void sr11();
  void sr12();
  void sr13();
  void sr14();
  void sr15();
};

} // end of namespace

#endif
